// Generated by gencpp from file teleop_msgs/GTParamsRequest.msg
// DO NOT EDIT!


#ifndef TELEOP_MSGS_MESSAGE_GTPARAMSREQUEST_H
#define TELEOP_MSGS_MESSAGE_GTPARAMSREQUEST_H


#include <string>
#include <vector>
#include <memory>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace teleop_msgs
{
template <class ContainerAllocator>
struct GTParamsRequest_
{
  typedef GTParamsRequest_<ContainerAllocator> Type;

  GTParamsRequest_()
    : d_ac(0.0)
    , K_ac()
    , B_ac()  {
    }
  GTParamsRequest_(const ContainerAllocator& _alloc)
    : d_ac(0.0)
    , K_ac(_alloc)
    , B_ac(_alloc)  {
  (void)_alloc;
    }



   typedef double _d_ac_type;
  _d_ac_type d_ac;

   typedef std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> _K_ac_type;
  _K_ac_type K_ac;

   typedef std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> _B_ac_type;
  _B_ac_type B_ac;





  typedef boost::shared_ptr< ::teleop_msgs::GTParamsRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::teleop_msgs::GTParamsRequest_<ContainerAllocator> const> ConstPtr;

}; // struct GTParamsRequest_

typedef ::teleop_msgs::GTParamsRequest_<std::allocator<void> > GTParamsRequest;

typedef boost::shared_ptr< ::teleop_msgs::GTParamsRequest > GTParamsRequestPtr;
typedef boost::shared_ptr< ::teleop_msgs::GTParamsRequest const> GTParamsRequestConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::teleop_msgs::GTParamsRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::teleop_msgs::GTParamsRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}


template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator==(const ::teleop_msgs::GTParamsRequest_<ContainerAllocator1> & lhs, const ::teleop_msgs::GTParamsRequest_<ContainerAllocator2> & rhs)
{
  return lhs.d_ac == rhs.d_ac &&
    lhs.K_ac == rhs.K_ac &&
    lhs.B_ac == rhs.B_ac;
}

template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator!=(const ::teleop_msgs::GTParamsRequest_<ContainerAllocator1> & lhs, const ::teleop_msgs::GTParamsRequest_<ContainerAllocator2> & rhs)
{
  return !(lhs == rhs);
}


} // namespace teleop_msgs

namespace ros
{
namespace message_traits
{





template <class ContainerAllocator>
struct IsMessage< ::teleop_msgs::GTParamsRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::teleop_msgs::GTParamsRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::teleop_msgs::GTParamsRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::teleop_msgs::GTParamsRequest_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::teleop_msgs::GTParamsRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::teleop_msgs::GTParamsRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::teleop_msgs::GTParamsRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "014b0389b0a3f54b787ab0a0083a4b49";
  }

  static const char* value(const ::teleop_msgs::GTParamsRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x014b0389b0a3f54bULL;
  static const uint64_t static_value2 = 0x787ab0a0083a4b49ULL;
};

template<class ContainerAllocator>
struct DataType< ::teleop_msgs::GTParamsRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "teleop_msgs/GTParamsRequest";
  }

  static const char* value(const ::teleop_msgs::GTParamsRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::teleop_msgs::GTParamsRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "float64 d_ac\n"
"float64[] K_ac\n"
"float64[] B_ac\n"
;
  }

  static const char* value(const ::teleop_msgs::GTParamsRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::teleop_msgs::GTParamsRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.d_ac);
      stream.next(m.K_ac);
      stream.next(m.B_ac);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct GTParamsRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::teleop_msgs::GTParamsRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::teleop_msgs::GTParamsRequest_<ContainerAllocator>& v)
  {
    s << indent << "d_ac: ";
    Printer<double>::stream(s, indent + "  ", v.d_ac);
    s << indent << "K_ac[]" << std::endl;
    for (size_t i = 0; i < v.K_ac.size(); ++i)
    {
      s << indent << "  K_ac[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.K_ac[i]);
    }
    s << indent << "B_ac[]" << std::endl;
    for (size_t i = 0; i < v.B_ac.size(); ++i)
    {
      s << indent << "  B_ac[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.B_ac[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // TELEOP_MSGS_MESSAGE_GTPARAMSREQUEST_H
